чување 01ce0d7e91f15f599a988ce1cb199039679309c4
родитељ f5c4a5db82f0d6bd47af671f62a738c92835be5e
Аутор: Страхиња Радић <contact@strahinja.org>
Датум: Fri, 23 Feb 2024 17:10:03 +0100
Replace redo with POSIX make
Signed-off-by: Страхиња Радић <contact@strahinja.org>
Diffstat:
измењених датотека: 44, додавања: 252(+), брисања: 647(-)
diff --git a/INSTALL b/INSTALL
@@ -1,7 +1,7 @@
Prerequisites
=============
-* C compiler - defaults in config.redo
+* C compiler - defaults in config.mk
Optional dependencies
@@ -22,22 +22,15 @@ Install
$ git clone https://git.sr.ht/~strahinja/slweb
$ cd slweb
$ su
-
-If you have djb redo:
-
- # redo install
-
-if you don't:
-
- # ./do install
+ # make install
Persistent build configuration file
-----------------------------------
-The file config.redo will be sourced when building targets which also accept
-configuration through environment variables. For example, CC and PREFIX
-are specified in config.redo.
+The file config.mk will be included by make when building targets which also
+accept configuration through environment variables. For example, CC and PREFIX
+are specified in config.mk.
OpenBSD
diff --git a/Makefile b/Makefile
@@ -0,0 +1,63 @@
+include config.mk
+
+.SUFFIXES: .1.in .1 .h.in .h .c .o
+
+.1.in.1: version date
+ sh -x replacepat $< > $@
+
+.h.in.h: version date
+ sh -x replacepat $< > $@
+
+all: $(PROG) $(MANPAGE) examples
+
+examples:
+ make -C examples all
+
+date:
+ sh makedate
+
+version:
+ sh makeversion
+
+slweb.o: slweb.c defs.h utf8.h version.h
+
+utf8.o: utf8.c utf8.h
+
+strlcpy.o: strlcpy.c
+
+strlcat.o: strlcat.c
+
+$(PROG): $(OBJS)
+ $(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)
+
+examples:
+ make -C examples all
+
+clean:
+ make -C examples clean
+ rm -f version date version.h *.o *.xz *~ $(PROG) $(MANPAGE)
+
+install: all
+ $(INSTALL) -Dm 0644 $(MANPAGE) $(MANPREFIX)/man1/$(MANPAGE)
+ make -C examples install
+ $(INSTALL) -Dm 0644 README $(DOCDIR)/README
+ $(INSTALL) -Dm 0644 LICENSE $(DOCDIR)/LICENSE
+ $(INSTALL) -Dm 0755 $(PROG) $(BINDIR)/$(PROG)
+
+uninstall:
+ rm -f $(MANPREFIX)/man1/$(MANPAGE)
+ rmdir $(MANPREFIX)/man1 2>/dev/null || true
+ rmdir $(MANPREFIX) 2>/dev/null || true
+ rm -f $(DOCDIR)/README
+ rm -f $(DOCDIR)/LICENSE
+ rmdir $(DOCDIR) 2>/dev/null || true
+ rm -f $(PROG) $(BINDIR)/$(PROG)
+ rmdir $(BINDIR) 2>/dev/null || true
+
+test: all
+ sh runtests
+
+pack: all version
+ sh -x mkpack
+
+.PHONY: all clean examples install uninstall pack test
diff --git a/TODO b/TODO
@@ -1,14 +1,7 @@
TODO
====
-[x] Critical: There is no sys/prctl.h in OpenBSD?
- [x] Immediate bandaid solution (missing functionality under OpenBSD)
- [/] Real solution (children die with parent)
- - Is there actually any need?
-
-[x] Switch to strlcpy/strlcat
-
-[ ] Switch to POSIX make
+[x] Switch to POSIX make
< > Add <abbr>?
diff --git a/TODO.done b/TODO.done
@@ -1,6 +1,13 @@
Done TODOs
==========
+[x] Critical: There is no sys/prctl.h in OpenBSD?
+ [x] Immediate bandaid solution (missing functionality under OpenBSD)
+ [/] Real solution (children die with parent)
+ - Is there actually any need?
+
+[x] Switch to strlcpy/strlcat
+
[x] Get rid of </p> (not required in HTML5) and ST_PARA_OPEN? That would also
get rid of stray </p>s and simplify things a bit
diff --git a/all.do b/all.do
@@ -1,2 +0,0 @@
-. ./config.redo
-redo-ifchange slweb slweb.1"$MANSUFFIX" examples/all
diff --git a/clean.do b/clean.do
@@ -1,3 +0,0 @@
-. ./config.redo
-rm -f *.o *~ slweb $MANPAGES *.1 version.h version date *.pdf *.html \
- examples/*/*.html
diff --git a/config.mk b/config.mk
@@ -0,0 +1,26 @@
+CC = cc
+CFLAGS = -g -Wall -pedantic -std=c99 -D_POSIX_C_SOURCE=200809L \
+ -D_XOPEN_SOURCE=700
+# OpenBSD
+#CFLAGS = -g -Wall -pedantic -std=c99 -D_POSIX_C_SOURCE=200809L \
+# -D_XOPEN_SOURCE=700 -D_BSD_SOURCE
+HTMLS = basic/index.html blockquote/index.html breakmarks/index.html \
+ csv-tsv/index-csv.html csv-tsv/index.html \
+ footnotes/inline.html footnotes/index.html \
+ links/index.html lists/index.html \
+ macros/index.html math/index.html tables/index.html \
+ tags/index.html
+INSTALL = install
+LIBS =
+OBJS = slweb.o strlcat.o strlcpy.o utf8.o
+PREFIX = /usr/local
+PROG = slweb
+
+# Derived macros
+BINDIR = $(PREFIX)/bin
+DOCDIR = $(PREFIX)/share/doc/$(PROG)
+EXDIR = $(DOCDIR)
+MANPREFIX = $(PREFIX)/share/man
+# OpenBSD
+#MANPREFIX = $(PREFIX)/man
+MANPAGE = $(PROG).1
diff --git a/config.redo b/config.redo
@@ -1,21 +0,0 @@
-PREFIX=${PREFIX:-/usr/local}
-
-BINDIR=$PREFIX/bin
-DOCDIR=$PREFIX/share/doc/slweb
-MANPREFIX=$PREFIX/share/man
-
-# OpenBSD
-#MANPREFIX=$PREFIX/man
-
-PROGS="slweb"
-DOCS="README LICENSE $(find examples -type f -print)"
-MANSUFFIX=${MANSUFFIX-$(command -v gzip >/dev/null && printf ".gz")}
-MANPAGES="slweb.1${MANSUFFIX}"
-
-CC=${CC:-gcc -g -Wall -pedantic -std=c99 -D_POSIX_C_SOURCE=200809L \
--D_XOPEN_SOURCE=700}
-STRIP=${STRIP:-:}
-
-# OpenBSD
-#CC=${CC:-cc -g -Wall -pedantic -std=c99 -D_POSIX_C_SOURCE=200809L \
-#-D_XOPEN_SOURCE=700 -D_BSD_SOURCE}
diff --git a/date.do b/date.do
@@ -1,20 +0,0 @@
-FALLBACKDATE=${FALLBACKDATE:-unknown}
-LC_ALL=C
-export LC_ALL
-user=$(unalias ls >/dev/null 2>&1 || true; \
- command ls -ld . | awk '{print $3}')
-e_user=$(id -un)
-if [ -d .git ] && command -v git >/dev/null 2>&1; then
- if [ "$e_user" = "$user" ]; then
- git log --format=format:%cd \
- --date=format:"%B %d, %Y" -1 @ >$3
- else
- su "${user}" -c 'env LC_ALL=C git log --format=format:%cd \
- --date=format:"%B %d, %Y" -1 @' >$3
- fi
- echo >>$3
-else
- printf "%s\n" "$FALLBACKDATE" >$3
-fi
-redo-always
-redo-stamp <$3
diff --git a/default.do b/default.do
@@ -1,10 +0,0 @@
-if [ -r $1.in ]; then
- redo-ifchange $1.in version date
- read VERSION <version
- read DATE <date
- sed -e "s/%VERSION%/$VERSION/g" \
- -e "s/%DATE%/$DATE/g" <$1.in
-else
- echo "$0: don't know how to build '$1'" >&2
- exit 99
-fi
diff --git a/default.gz.do b/default.gz.do
@@ -1,2 +0,0 @@
-redo-ifchange $2
-gzip -cf $2 >$3
diff --git a/default.html.do b/default.html.do
@@ -1,2 +0,0 @@
-redo-ifchange $2.slw slweb
-./slweb -d ${2%/*} $2.slw >$3
diff --git a/default.o.do b/default.o.do
@@ -1,5 +0,0 @@
-sed -n 's/^#include "\([^"]*\)"/\1/p' ${2%.o}.c | \
- xargs redo-ifchange
-redo-ifchange $2.c
-. ./config.redo
-${CC} -o $3 -c $2.c
diff --git a/default.pdf.do b/default.pdf.do
@@ -1,2 +0,0 @@
-redo-ifchange $2.1
-groff -mandoc -t -T pdf $2.1 >$3
diff --git a/do b/do
@@ -1,446 +0,0 @@
-#!/usr/bin/env sh
-#
-# A minimal alternative to djb redo that doesn't support incremental builds.
-# For the full version, visit http://github.com/apenwarr/redo
-#
-# The author disclaims copyright to this source file and hereby places it in
-# the public domain. (2010 12 14; updated 2019 02 24)
-#
-USAGE="
-usage: do [-d] [-x] [-v] [-c] <targets...>
- -d print extra debug messages (mostly about dependency checks)
- -v run .do files with 'set -v'
- -x run .do files with 'set -x'
- -c clean up all old targets before starting
-
- Note: do is an implementation of redo that does *not* check dependencies.
- It will never rebuild a target it has already built, unless you use -c.
-"
-
-# CDPATH apparently causes unexpected 'cd' output on some platforms.
-unset CDPATH
-
-# By default, no output coloring.
-green=""
-bold=""
-plain=""
-
-if [ -n "$TERM" -a "$TERM" != "dumb" ] && tty <&2 >/dev/null 2>&1; then
- green="$(printf '\033[32m')"
- bold="$(printf '\033[1m')"
- plain="$(printf '\033[m')"
-fi
-
-# The 'seq' command is not available on all platforms.
-_seq() {
- local x=0 max="$1"
- while [ "$x" -lt "$max" ]; do
- x=$((x + 1))
- echo "$x"
- done
-}
-
-# Split $1 into a dir part ($_dirsplit_dir) and base filename ($_dirsplit_base)
-_dirsplit() {
- _dirsplit_base=${1##*/}
- _dirsplit_dir=${1%$_dirsplit_base}
-}
-
-# Like /usr/bin/dirname, but avoids a fork and uses _dirsplit semantics.
-qdirname() (
- _dirsplit "$1"
- dir=${_dirsplit_dir%/}
- echo "${dir:-.}"
-)
-
-_dirsplit "$0"
-REDO=$(cd "$(pwd -P)" &&
- cd "${_dirsplit_dir:-.}" &&
- echo "$PWD/$_dirsplit_base")
-export REDO
-_cmd=$_dirsplit_base
-
-DO_TOP=
-if [ -z "$DO_BUILT" ]; then
- export _do_opt_debug=
- export _do_opt_exec=
- export _do_opt_verbose=
- export _do_opt_clean=
-fi
-while getopts 'dxvcj:h?' _opt; do
- case $_opt in
- d) _do_opt_debug=1 ;;
- x) _do_opt_exec=x ;;
- v) _do_opt_verbose=v ;;
- c) _do_opt_clean=1 ;;
- j) ;; # silently ignore, for compat with real redo
- \?|h|*) printf "%s" "$USAGE" >&2
- exit 99
- ;;
- esac
-done
-shift "$((OPTIND - 1))"
-_debug() {
- [ -z "$_do_opt_debug" ] || echo "$@" >&2
-}
-
-if [ -z "$DO_BUILT" -a "$_cmd" != "redo-whichdo" ]; then
- DO_TOP=1
- if [ "$#" -eq 0 ] && [ "$_cmd" = "do" -o "$_cmd" = "redo" ]; then
- set all # only toplevel redo has a default target
- fi
- export DO_STARTDIR="$(pwd -P)"
- # If starting /bin/pwd != $PWD, this will fix it.
- # That can happen when $PWD contains symlinks that the shell is
- # trying helpfully (but unsuccessfully) to hide from the user.
- cd "$DO_STARTDIR" || exit 99
- export DO_BUILT="$PWD/.do_built"
- if [ -z "$_do_opt_clean" -a -e "$DO_BUILT" ]; then
- echo "do: Incremental mode. Use -c for clean rebuild." >&2
- fi
- : >>"$DO_BUILT"
- sort -u "$DO_BUILT" >"$DO_BUILT.new"
- while read f; do
- [ -n "$_do_opt_clean" ] && printf "%s\0%s.did\0" "$f" "$f"
- printf "%s.did.tmp\0" "$f"
- done <"$DO_BUILT.new" |
- xargs -0 rm -f 2>/dev/null
- mv "$DO_BUILT.new" "$DO_BUILT"
- export DO_PATH="$DO_BUILT.dir"
- export PATH="$DO_PATH:$PATH"
- rm -rf "$DO_PATH"
- mkdir "$DO_PATH"
- for d in redo redo-ifchange redo-whichdo; do
- ln -s "$REDO" "$DO_PATH/$d"
- done
- for d in redo-ifcreate redo-stamp redo-always redo-ood \
- redo-targets redo-sources; do
- echo "#!/bin/sh" >"$DO_PATH/$d"
- chmod a+rx "$DO_PATH/$d"
- done
-fi
-
-
-# Chop the "file" part off a /path/to/file pathname.
-# Note that if the filename already ends in a /, we just remove the slash.
-_updir()
-{
- local v="${1%/*}"
- [ "$v" != "$1" ] && echo "$v"
- # else "empty" which means we went past the root
-}
-
-
-# Returns true if $1 starts with $2.
-_startswith()
-{
- [ "${1#"$2"}" != "$1" ]
-}
-
-
-# Returns true if $1 ends with $2.
-_endswith()
-{
- [ "${1%"$2"}" != "$1" ]
-}
-
-
-# Prints $1 if it's absolute, or $2/$1 if $1 is not absolute.
-_abspath()
-{
- local here="$2" there="$1"
- if _startswith "$1" "/"; then
- echo "$1"
- else
- echo "$2/$1"
- fi
-}
-
-
-# Prints $1 as a path relative to $PWD (not starting with /).
-# If it already doesn't start with a /, doesn't change the string.
-_relpath()
-{
- local here="$2" there="$1" out= hadslash=
- #echo "RP start '$there' hs='$hadslash'" >&2
- _startswith "$there" "/" || { echo "$there" && return; }
- [ "$there" != "/" ] && _endswith "$there" "/" && hadslash=/
- here=${here%/}/
- while [ -n "$here" ]; do
- #echo "RP out='$out' here='$here' there='$there'" >&2
- [ "${here%/}" = "${there%/}" ] && there= && break;
- [ "${there#$here}" != "$there" ] && break
- out=../$out
- _dirsplit "${here%/}"
- here=$_dirsplit_dir
- done
- there=${there#$here}
- if [ -n "$there" ]; then
- echo "$out${there%/}$hadslash"
- else
- echo "${out%/}$hadslash"
- fi
-}
-
-
-# Prints a "normalized relative" path, with ".." resolved where possible.
-# For example, a/b/../c will be reduced to just a/c.
-_normpath()
-(
- local path="$1" relto="$2" out= isabs=
- #echo "NP start '$path'" >&2
- if _startswith "$path" "/"; then
- isabs=1
- else
- path="${relto%/}/$path"
- fi
- set -f
- IFS=/
- for d in ${path%/}; do
- #echo "NP out='$out' d='$d'" >&2
- if [ "$d" = ".." ]; then
- out=$(_updir "${out%/}")/
- else
- out=$out$d/
- fi
- done
- #echo "NP out='$out' (done)" >&2
- out=${out%/}
- if [ -n "$isabs" ]; then
- echo "${out:-/}"
- else
- _relpath "${out:-/}" "$relto"
- fi
-)
-
-
-# Prints a "real" path, with all symlinks resolved where possible.
-_realpath()
-{
- local path="$1" relto="$2" isabs= rest=
- if _startswith "$path" "/"; then
- isabs=1
- else
- path="${relto%/}/$path"
- fi
- (
- for d in $(_seq 100); do
- #echo "Trying: $PWD--$path" >&2
- if cd -P "$path" 2>/dev/null; then
- # success
- pwd=$(pwd -P)
- #echo " chdir ok: $pwd--$rest" >&2
- np=$(_normpath "${pwd%/}/$rest" "$relto")
- if [ -n "$isabs" ]; then
- echo "$np"
- else
- _relpath "$np" "$relto"
- fi
- break
- fi
- _dirsplit "${path%/}"
- path=$_dirsplit_dir
- rest="$_dirsplit_base/$rest"
- done
- )
-}
-
-
-# List the possible names for default*.do files in dir $1 matching the target
-# pattern in $2. We stop searching when we find the first one that exists.
-_find_dofiles_pwd()
-{
- local dodir="$1" dofile="$2"
- _startswith "$dofile" "default." || dofile=${dofile#*.}
- while :; do
- dofile=default.${dofile#default.*.}
- echo "$dodir$dofile"
- [ -e "$dodir$dofile" ] && return 0
- [ "$dofile" = default.do ] && break
- done
- return 1
-}
-
-
-# List the possible names for default*.do files in $PWD matching the target
-# pattern in $1. We stop searching when we find the first name that works.
-# If there are no matches in $PWD, we'll search in .., and so on, to the root.
-_find_dofiles()
-{
- local target="$1" dodir= dofile= newdir=
- _debug "find_dofile: '$PWD' '$target'"
- dofile="$target.do"
- echo "$dofile"
- [ -e "$dofile" ] && return 0
-
- # Try default.*.do files, walking up the tree
- _dirsplit "$dofile"
- dodir=$_dirsplit_dir
- dofile=$_dirsplit_base
- [ -n "$dodir" ] && dodir=${dodir%/}/
- [ -e "$dodir$dofile" ] && return 0
- for i in $(_seq 100); do
- [ -n "$dodir" ] && dodir=${dodir%/}/
- #echo "_find_dofiles: '$dodir' '$dofile'" >&2
- _find_dofiles_pwd "$dodir" "$dofile" && return 0
- newdir=$(_realpath "${dodir}.." "$PWD")
- [ "$newdir" = "$dodir" ] && break
- dodir=$newdir
- done
- return 1
-}
-
-
-# Print the last .do file returned by _find_dofiles.
-# If that file exists, returns 0, else 1.
-_find_dofile()
-{
- local files="$(_find_dofiles "$1")"
- rv=$?
- #echo "files='$files'" >&2
- [ "$rv" -ne 0 ] && return $rv
- echo "$files" | {
- while read -r linex; do line=$linex; done
- printf "%s\n" "$line"
- }
-}
-
-
-# Actually run the given $dofile with the arguments in $@.
-# Note: you should always run this in a subshell.
-_run_dofile()
-{
- export DO_DEPTH="$DO_DEPTH "
- export REDO_TARGET="$PWD/$target"
- local line1
- set -e
- read line1 <"$PWD/$dofile" || true
- cmd=${line1#"#!/"}
- if [ "$cmd" != "$line1" ]; then
- set -$_do_opt_verbose$_do_opt_exec
- exec /$cmd "$PWD/$dofile" "$@"
- else
- set -$_do_opt_verbose$_do_opt_exec
- # If $dofile is empty, "." might not change $? at
- # all, so we clear it first with ":".
- :; . "$PWD/$dofile"
- fi
-}
-
-
-# Find and run the right .do file, starting in dir $1, for target $2,
-# providing a temporary output file as $3. Renames the temp file to $2 when
-# done.
-_do()
-{
- local dir="$1" target="$1$2" tmp="$1$2.redo.tmp" tdir=
- local dopath= dodir= dofile= ext=
- if [ "$_cmd" = "redo" ] ||
- ( [ ! -e "$target" -o -d "$target" ] &&
- [ ! -e "$target.did" ] ); then
- printf '%sdo %s%s%s%s\n' \
- "$green" "$DO_DEPTH" "$bold" "$target" "$plain" >&2
- dopath=$(_find_dofile "$target")
- if [ ! -e "$dopath" ]; then
- echo "do: $target: no .do file ($PWD)" >&2
- return 1
- fi
- _dirsplit "$dopath"
- dodir=$_dirsplit_dir dofile=$_dirsplit_base
- if _startswith "$dofile" "default."; then
- ext=${dofile#default}
- ext=${ext%.do}
- else
- ext=
- fi
- target=$PWD/$target
- tmp=$PWD/$tmp
- cd "$dodir" || return 99
- target=$(_relpath "$target" "$PWD") || return 98
- tmp=$(_relpath "$tmp" "$PWD") || return 97
- base=${target%$ext}
- tdir=$(qdirname "$target")
- [ ! -e "$DO_BUILT" ] || [ ! -w "$tdir/." ] ||
- : >>"$target.did.tmp"
- # $qtmp is a temporary file used to capture stdout.
- # Since it might be accidentally deleted as a .do file
- # does its work, we create it, then open two fds to it,
- # then immediately delete the name. We use one fd to
- # redirect to stdout, and the other to read from after,
- # because there's no way to fseek(fd, 0) in sh.
- qtmp=$DO_PATH/do.$$.tmp
- (
- rm -f "$qtmp"
- ( _run_dofile "$target" "$base" "$tmp" >&3 3>&- 4<&- )
- rv=$?
- if [ $rv != 0 ]; then
- printf "do: %s%s\n" "$DO_DEPTH" \
- "$target: got exit code $rv" >&2
- rm -f "$tmp.tmp" "$tmp.tmp2" "$target.did"
- return $rv
- fi
- echo "$PWD/$target" >>"$DO_BUILT"
- if [ ! -e "$tmp" ]; then
- # if $3 wasn't created, copy from stdout file
- cat <&4 >$tmp
- # if that's zero length too, forget it
- [ -s "$tmp" ] || rm -f "$tmp"
- fi
- ) 3>$qtmp 4<$qtmp # can't use "|| return" here...
- # ...because "|| return" would mess up "set -e" inside the ()
- # on some shells. Running commands in "||" context, even
- # deep inside, will stop "set -e" from functioning.
- rv=$?
- [ "$rv" = 0 ] || return "$rv"
- mv "$tmp" "$target" 2>/dev/null
- [ -e "$target.did.tmp" ] &&
- mv "$target.did.tmp" "$target.did" ||
- : >>"$target.did"
- else
- _debug "do $DO_DEPTH$target exists." >&2
- fi
-}
-
-
-# Implementation of the "redo" command.
-_redo()
-{
- local i startdir="$PWD" dir base
- set +e
- for i in "$@"; do
- i=$(_abspath "$i" "$startdir")
- (
- cd "$DO_STARTDIR" || return 99
- i=$(_realpath "$(_relpath "$i" "$PWD")" "$PWD")
- _dirsplit "$i"
- dir=$_dirsplit_dir base=$_dirsplit_base
- _do "$dir" "$base"
- )
- [ "$?" = 0 ] || return 1
- done
-}
-
-
-# Implementation of the "redo-whichdo" command.
-_whichdo()
-{
- _find_dofiles "$1"
-}
-
-
-case $_cmd in
- do|redo|redo-ifchange) _redo "$@" ;;
- redo-whichdo) _whichdo "$1" ;;
- do.test) ;;
- *) printf "do: '%s': unexpected redo command" "$_cmd" >&2; exit 99 ;;
-esac
-[ "$?" = 0 ] || exit 1
-
-if [ -n "$DO_TOP" ]; then
- if [ -n "$_do_opt_clean" ]; then
- echo "do: Removing stamp files..." >&2
- [ ! -e "$DO_BUILT" ] ||
- while read f; do printf "%s.did\0" "$f"; done <"$DO_BUILT" |
- xargs -0 rm -f 2>/dev/null
- fi
-fi
diff --git a/examples/Makefile b/examples/Makefile
@@ -0,0 +1,47 @@
+include ../config.mk
+
+.SUFFIXES: .html .slw
+
+.slw.html:
+ ../slweb -d $(<D) $< > $@
+
+all: $(HTMLS)
+ make -C includes all
+
+clean:
+ make -C includes clean
+ find . -name '*.html' -exec rm {} \;
+ rm -f *~
+
+install: all
+ $(INSTALL) -Dm 0644 basic/index.html $(EXDIR)/basic/index.html
+ $(INSTALL) -Dm 0644 blockquote/index.html $(EXDIR)/blockquote/index.html
+ $(INSTALL) -Dm 0644 breakmarks/index.html $(EXDIR)/breakmarks/index.html
+ $(INSTALL) -Dm 0644 csv-tsv/index-csv.html $(EXDIR)/csv-tsv/index-csv.html
+ $(INSTALL) -Dm 0644 csv-tsv/index.html $(EXDIR)/csv-tsv/index.html
+ $(INSTALL) -Dm 0644 footnotes/inline.html $(EXDIR)/footnotes/inline.html
+ $(INSTALL) -Dm 0644 footnotes/index.html $(EXDIR)/footnotes/index.html
+ $(INSTALL) -Dm 0644 links/index.html $(EXDIR)/links/index.html
+ $(INSTALL) -Dm 0644 lists/index.html $(EXDIR)/lists/index.html
+ $(INSTALL) -Dm 0644 macros/index.html $(EXDIR)/macros/index.html
+ $(INSTALL) -Dm 0644 math/index.html $(EXDIR)/math/index.html
+ $(INSTALL) -Dm 0644 tables/index.html $(EXDIR)/tables/index.html
+ $(INSTALL) -Dm 0644 tags/index.html $(EXDIR)/tags/index.html
+
+uninstall:
+ rm -f $(EXDIR)/basic/index.html
+ rm -f $(EXDIR)/blockquote/index.html
+ rm -f $(EXDIR)/breakmarks/index.html
+ rm -f $(EXDIR)/csv-tsv/index-csv.html
+ rm -f $(EXDIR)/csv-tsv/index.html
+ rm -f $(EXDIR)/footnotes/inline.html
+ rm -f $(EXDIR)/footnotes/index.html
+ rm -f $(EXDIR)/links/index.html
+ rm -f $(EXDIR)/lists/index.html
+ rm -f $(EXDIR)/macros/index.html
+ rm -f $(EXDIR)/math/index.html
+ rm -f $(EXDIR)/tables/index.html
+ rm -f $(EXDIR)/tags/index.html
+ rmdir $(EXDIR) 2>/dev/null || true
+
+.PHONY: all clean install uninstall
diff --git a/examples/all.do b/examples/all.do
@@ -1,3 +0,0 @@
-for d in *; do
- [ -d $d ] && echo $d/all
-done | xargs redo-ifchange
diff --git a/examples/basic/all.do b/examples/basic/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/blockquote/all.do b/examples/blockquote/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/breakmarks/all.do b/examples/breakmarks/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/csv-tsv/all.do b/examples/csv-tsv/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html index-csv.html
diff --git a/examples/footnotes/all.do b/examples/footnotes/all.do
@@ -1 +0,0 @@
-echo "index.html inline.html" | xargs redo-ifchange
diff --git a/examples/includes/Makefile b/examples/includes/Makefile
@@ -0,0 +1,25 @@
+include ../../config.mk
+
+.SUFFIXES: .html .slw
+
+.slw.html:
+ ../../slweb -d $(<D) $< > $@
+
+all: index.html
+
+index.html: index.slw bugs.slw description.slw examples.slw inc/copy.slw \
+ inc/footer.slw inc/header.slw index.slw options.slw reference.slw \
+ seealso.slw
+
+clean:
+ find . -name '*.html' -exec rm {} \;
+ rm -f *~
+
+install: all
+ $(INSTALL) -Dm 0644 index.html $(EXDIR)/examples/includes/index.html
+
+uninstall:
+ rm -f $(EXDIR)/includes/index.html
+ rmdir $(EXDIR) 2>/dev/null || true
+
+.PHONY: all clean install uninstall
diff --git a/examples/includes/all.do b/examples/includes/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/includes/index.html.do b/examples/includes/index.html.do
@@ -1,4 +0,0 @@
-for f in *.slw inc/*.slw; do
- echo $f
-done | xargs redo-ifchange
-../../slweb ${2%.*}.slw >$3
diff --git a/examples/links/all.do b/examples/links/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/lists/all.do b/examples/lists/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/macros/all.do b/examples/macros/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/math/all.do b/examples/math/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/tables/all.do b/examples/tables/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/examples/tags/all.do b/examples/tags/all.do
@@ -1 +0,0 @@
-redo-ifchange index.html
diff --git a/install.do b/install.do
@@ -1,12 +0,0 @@
-redo-ifchange all
-. ./config.redo
-install -d "$DOCDIR" "$BINDIR" "${MANPREFIX}/man1"
-for docfile in $DOCS; do
- install -Dm 0644 "${docfile}" "${DOCDIR}/${docfile}"
-done
-for binfile in $PROGS; do
- install -Dm 0755 "${binfile}" "${BINDIR}/${binfile}"
-done
-for manfile in $MANPAGES; do
- install -Dm 0644 "${manfile}" "${MANPREFIX}/man1/${manfile}"
-done
diff --git a/makedate b/makedate
@@ -0,0 +1,20 @@
+#!/bin/sh -x
+# vim: set ft=bash:
+FALLBACKDATE=${FALLBACKDATE:-unknown}
+LC_ALL=C
+export LC_ALL
+user=$(unalias ls >/dev/null 2>&1 || true; \
+ command ls -ld . | awk '{print $3}')
+e_user=$(id -un)
+if [ -d .git ] && command -v git >/dev/null 2>&1; then
+ if [ "$e_user" = "$user" ]; then
+ git log --format=format:%cd \
+ --date=format:"%B %d, %Y" -1 @ >date
+ else
+ su "${user}" -c 'env LC_ALL=C git log --format=format:%cd \
+ --date=format:"%B %d, %Y" -1 @' >date
+ fi
+ echo >>date
+else
+ printf "%s\n" "$FALLBACKDATE" >date
+fi
diff --git a/makeversion b/makeversion
@@ -0,0 +1,18 @@
+#!/bin/sh -x
+# vim: set ft=bash:
+FALLBACKVER=${FALLBACKVER:-unknown}
+LC_ALL=C
+export LC_ALL
+user=$(unalias ls >/dev/null 2>&1 || true; \
+ command ls -ld . | awk '{print $3}')
+e_user=$(id -un)
+if [ -d .git ] && command -v git >/dev/null 2>&1; then
+ if [ "$e_user" = "$user" ]; then
+ git describe 2>/dev/null | sed 's/^v//' >version
+ else
+ su "${user}" -c 'git describe' 2>/dev/null |
+ sed 's/^v//' >version
+ fi
+else
+ printf "%s\n" "$FALLBACKVER" >version
+fi
diff --git a/mkpack b/mkpack
@@ -0,0 +1,11 @@
+#!/bin/sh -x
+# vim: set ft=bash:
+DISTDIR=slweb-$(cat version)
+mkdir "$DISTDIR"
+for f in $(git ls-files); do
+ d="$DISTDIR"/"$(dirname "$f")"
+ mkdir -p "$d"
+ cp "$f" "$d"/
+done
+tar -cf - "$DISTDIR" | xz -9v - > "$DISTDIR".tar.xz
+rm -fr "$DISTDIR"
diff --git a/pack.do b/pack.do
@@ -1,13 +0,0 @@
-redo all
-redo-ifchange version
-read VERSION <version
-VERSION=$(echo $VERSION | sed 's/^v//')
-DISTDIR=slweb-$VERSION
-mkdir $DISTDIR
-for f in $(git ls-files); do
- d=$DISTDIR/$(dirname $f)
- mkdir -p $d
- cp $f $d
-done
-tar cvf $DISTDIR.tar.xz $DISTDIR >/dev/null
-rm -fr $DISTDIR
diff --git a/rebuild.do b/rebuild.do
@@ -1,2 +0,0 @@
-redo clean
-redo all
diff --git a/replacepat b/replacepat
@@ -0,0 +1,5 @@
+#!/bin/sh -x
+# vim: set ft=bash:
+DATE=$(cat date)
+VERSION=$(cat version)
+sed -e 's|%VERSION%|'"$VERSION"'|g' -e 's|%DATE%|'"$DATE"'|g' $1
diff --git a/runtests b/runtests
@@ -0,0 +1,24 @@
+#!/bin/sh
+testdir=tests
+cat <<! >&2
+TEST RESULTS
+===========================================================
+!
+error=''
+find "$testdir" -type f \( -perm -100 -o -perm -010 -o -perm -001 \) -exec {} \; |
+awk 'BEGIN { FS="\t"; maxlen = 60; status = 0 }
+{
+ printf "%s%*s%s\n", $1, maxlen-5-length($1), " ", $2;
+ if ($2 == "FAIL")
+ status = 1
+}
+END { exit status }' >&2 || error=1
+cat <<! >&2
+===========================================================
+!
+if [ -n "$error" ]; then
+ printf "Some tests were unsuccessful - please report\n" >&2
+ exit 99
+else
+ printf "All tests passed\n" >&2
+fi
diff --git a/slweb.do b/slweb.do
@@ -1,10 +0,0 @@
-. ./config.redo
-for f in *.h.in; do
- echo $f | sed -e's/\.in$//g'
-done | xargs redo-ifchange
-for f in *.h *.c; do
- echo $f
- echo $f | sed -e's/\.c$/.o/g'
-done | xargs redo-ifchange
-${CC} -o $3 slweb.o utf8.o >&2
-${STRIP} $3 >&2
diff --git a/slweb.html.do b/slweb.html.do
@@ -1,7 +0,0 @@
-redo-ifchange ${2%.html}.1
-#groff -mandoc -t -Tutf8 $2.1 | man2html -topm 0 -botm 0 >$3
-groff -mandoc -t -Tlatin1 ${2%.html}.1 \
- | man2html -toc -title "${2%.html} manual" -topm 0 -botm 0 >$3.tmp
-sed '/<TITLE/a<style>html,body{font-family: sans-serif}<\/style>' $3.tmp \
- > $3
-rm $3.tmp
diff --git a/test.do b/test.do
@@ -1,24 +0,0 @@
-redo-ifchange slweb
-testdir=tests
-cat <<! >&2
-TEST RESULTS
-===========================================================
-!
-error=''
-find "$testdir" -type f -perm +a+x -exec {} \; |
-awk 'BEGIN { FS="\t"; maxlen = 60; status = 0 }
-{
- printf "%s%*s%s\n", $1, maxlen-5-length($1), " ", $2;
- if ($2 == "FAIL")
- status = 1
-}
-END { exit status }' >&2 || error=1
-cat <<! >&2
-===========================================================
-!
-if [ -n "$error" ]; then
- printf "Some tests were unsuccessful - please report\n" >&2
- exit 99
-else
- printf "All tests passed\n" >&2
-fi
diff --git a/uninstall.do b/uninstall.do
@@ -1,10 +0,0 @@
-. ./config.redo
-for docfile in $DOCS; do
- rm -f "${DOCDIR}/${docfile}"
-done
-for binfile in $PROGS; do
- rm -f "${BINDIR}/${binfile}"
-done
-for manfile in $MANPAGES; do
- rm -f "${MANPREFIX}/man1/${manfile}"
-done
diff --git a/version.do b/version.do
@@ -1,17 +0,0 @@
-FALLBACKVER=${FALLBACKVER:-unknown}
-LC_ALL=C
-export LC_ALL
-user=$(unalias ls >/dev/null 2>&1 || true; \
- command ls -ld . | awk '{print $3}')
-e_user=$(id -un)
-if [ -d .git ] && command -v git >/dev/null 2>&1; then
- if [ "$e_user" = "$user" ]; then
- git describe 2>/dev/null | sed 's/^v//' >$3
- else
- su "${user}" -c 'git describe' 2>/dev/null | sed 's/^v//' >$3
- fi
-else
- printf "%s\n" "$FALLBACKVER" >$3
-fi
-redo-always
-redo-stamp <$3